/*
*	Implementierung des Evolutions-Algorithmus	
*
* 	Autor: Viktor Herzog
* <applet code="Evo" width=450 height=515>
* </applet>
*
*/

import java.applet.*;
import java.awt.*;

public class Evo extends Applet {
Button Go=new Button("Go!");
Button Stop=new Button("Stop");
Button Next=new Button("Next");
Button Clear=new Button("Clear");
TextField Population=new TextField("0",4);
TextField Generation=new TextField("0",4);
TextField Total=new TextField("0",8);
Label Populationl=new Label("Population",Label.LEFT);
Label Generationl=new Label("Schritt",Label.LEFT);
Label Totall=new Label("Total",Label.LEFT);
int feld[][] = new int[46][46];
boolean run=false;
boolean next=false;
int pop;
int gen=0;
int total;

	public void init() {
		setLayout(null);
		setBackground(Color.gray);
		Generation.setBackground(Color.white);
		Population.setBackground(Color.white);
		Total.setBackground(Color.white);
		add(Go);
		add(Stop);
		add(Next);
		add(Clear);
		add(Population);
		add(Generation);
		add(Total);
		add(Populationl);
		add(Generationl);
		add(Totall);
		Generationl.reshape(10,455,80,22);
		Populationl.reshape(100,455,80,22);
		Totall.reshape(190,455,80,22);
		Generation.reshape(5,478,80,30);
		Population.reshape(95,478,80,30);
		Total.reshape(185,478,80,30);
		Go.reshape(360,460,40,35);
		Stop.reshape(400,460,40,35);
		Next.reshape(320,460,40,35);
		Clear.reshape(278,460,42,35);
		Go.enable();
		Clear.enable();
		Next.enable();
		Stop.disable();
		Generation.setEditable(false);
		Total.setEditable(false);
		Population.setEditable(false);
	}

	public void paint(Graphics g) {
		this.update(g);
	}

	public void update(Graphics g) {
		int i;
		int j;
		int nachbar;
		int pop_copy;
		int total_copy;
		g.setColor(Color.darkGray);
		for (i=0; i<=450; i+=10) {
			g.drawLine(i,0,i,450);
			g.drawLine(0,i,450,i);
		}
		pop_copy=pop;
		total_copy=total;
		pop=0;
			for (i=0; i<45; i++) 
				for (j=0; j<45;j++) {
					if (feld[i][j]==1) {
						g.setColor(Color.green);			
						g.fillRect(i*10+1,j*10+1,9,9);
						pop++;
					}
					if (feld[i][j]==0) {
						g.setColor(Color.gray);	
						g.fillRect(i*10+1,j*10+1,9,9);
					}
				}
		if ((run)||(next)) {
			for (i=0; i<45; i++) 
				for (j=0; j<45;j++) {
					nachbar=this.nachbar(i,j);
					if ((feld[i][j]==1)&&((nachbar<2)||(nachbar>3))) feld[i][j]=-1;
					if ((feld[i][j]==0)&&(nachbar==3)) { 
								feld[i][j]=-2;
								total++;
					}
				}
			for (i=0; i<45; i++) 
				for (j=0; j<45;j++) 
					if (feld[i][j]<0) feld[i][j]=-1-feld[i][j];
			gen++;
			this.repaint();	
			if ((!(next))&&(total==total_copy)&&(pop==pop_copy)) {
					run=false;
					gen--;
					Go.enable();
					Next.enable();
					Clear.enable();
					Stop.disable();
			}
			if (next) next=false;
		}
		
		Generation.setText((new String()).valueOf(gen));
		Population.setText((new String()).valueOf(pop));
		Total.setText((new String()).valueOf(total));
	}

	public int nachbar(int i, int j) {
		int count=0;
		if ((i>0)&&(j>0)&&((feld[i-1][j-1]==1)||(feld[i-1][j-1]==-1))) count++;
		if ((i>0)&&((feld[i-1][j]==1)||(feld[i-1][j]==-1))) count++;
		if ((j>0)&&((feld[i][j-1]==1)||(feld[i][j-1]==-1))) count++;
		if ((i<49)&&(j<49)&&((feld[i+1][j+1]==1)||(feld[i+1][j+1]==-1))) count++;
		if ((i<49)&&((feld[i+1][j]==1)||(feld[i+1][j]==-1))) count++;
		if ((j<49)&&((feld[i][j+1]==1)||(feld[i][j+1]==-1))) count++;
		if ((i>0)&&(j<49)&&((feld[i-1][j+1]==1)||(feld[i-1][j+1]==-1))) count++;
		if ((i<49)&&(j>0)&&((feld[i+1][j-1]==1)||(feld[i+1][j-1]==-1))) count++;
	return count;
	}


	public boolean handleEvent (Event evt) {
	int X;
	int Y;
	int i;
	int j;
	int nachbar;
		if ((!run)&&(evt.id==Event.MOUSE_UP)&&(evt.y<=450)) {
			X =  evt.x/10;
			Y =  evt.y/10;
			feld[X][Y]=1-feld[X][Y];
			if (feld[X][Y]==1) total++;
			if ((feld[X][Y]==0)&&(gen==0)) total--;
			this.repaint();
		 }
		if ((evt.id==Event.ACTION_EVENT)&&(evt.target==Go)) {
			run=true;
			Go.disable();
			Next.disable();
			Clear.disable();
			Stop.enable();
			this.repaint();

			
		}
		if ((evt.id==Event.ACTION_EVENT)&&(evt.target==Stop)) {
			run=false;
			Go.enable();
			Next.enable();
			Clear.enable();
			Stop.disable();
		}

		if ((evt.id==Event.ACTION_EVENT)&&(evt.target==Clear)) {
			for (i=0; i<45; i++) 
				for (j=0; j<45;j++) 
					feld[i][j]=0;
			pop=0;
			total=0;
			gen=0;
			this.repaint();	
		}
		if ((evt.id==Event.ACTION_EVENT)&&(evt.target==Next)) {
			next=true;
			this.repaint();
		}


		return super.handleEvent(evt);
	}
}
