#
# Mas2TeX Spec-File for RPM-packager
#
#   Bei jedem Versionswechsel Version und Release aendern !!
#

# Required packages
#    gnuplot   : GNUPlot
#    gs        : GhostScript
#    l2h       : LaTeX2HTML (>= 2K.1beta, 1.50)
#    netpbm    : GifToPnm   (>= 9.14)
#    perl      : Perl       (>= 5.6.0)
#    perl_tk   : Perl/Tk
#    tetex     : LaTeX
#    transfig  : Fig2Dev
#    dvipdfm   : DVI->PDF compiler
#
requires: perl >= 5.6.0, perl_tk, gnuplot, gs, l2h >= 1.50, netpbm >= 9.14, tetex, transfig, dvipdfm

%define name	mas2tex
%define version	3.1
%define release	7
%define prefix	/usr

Summary:   LaTeX-extension to create PostScript or HTML output including multimedia objects
Name:      %{name}
Version:   %{version}
Release:   %{release}
Copyright: ComputerScience, University of Osnabrueck, Germany
Group:     Applications/LaTeX
URL:       http://www-lehre.inf.uos.de/~mas2tex/
Vendor:    ComputerScience, University of Osnabrueck, Germany
Packager:  Carsten Wilhelm <carsten@informatik.uni-osnabrueck.de>
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Source:    mas2tex-%{version}-%{release}.tar.gz
BuildArchitectures: noarch

%description
Mas2TeX is a preprocessor for LaTeX files, which can be used to generate
printable and online files froma single source. Mas2TeX creates different
LaTeX sources for each output format (supported are PostScript, PDF and
HTML). These sources can be used with either latex (and dvips or dvipdfm)
or latex2html. Mas2TeX can insert different objects for different output
formats, e.g. a video-file in HTML and a single picture for the printed
versions. Mas2TeX can include some media formats and knows how to convert
them for each output format.

%prep
%setup -n mas2tex-%{version}-%{release}

%build
./configure --prefix=%{prefix} && make

%install
rm -rf $RPM_BUILD_ROOT
make PREFIX=$RPM_BUILD_ROOT%{prefix} install

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{prefix}/bin/mas2tex -rebuild_config
/usr/bin/mktexlsr

%postun
/usr/bin/mktexlsr

%files
%defattr(-, root, root)
#%doc COPYING
%{prefix}
