###
### Color Class
###
package Color;
use Tk; 

local $COLOR;
local $GREEN;
local $RED;
local $BLUE;

###
### $cl = Color->new($topwindow, \&funkt_ref, $title) - Neue Color-Instanz
###
sub new {
    my($type, $parentwin, $callbackref, $title) = @_;

    my $self = {};
                                            
                                            
    $self->{'callbackref'} = $callbackref;  # Parameter in
    $self->{'parentwin'}   = $parentwin;    # Instanzvariable
    $self->{'title'}       = $title;        # sichern
    $self->{'filter'}      = $filter;       # sichern

    bless($self, $type);
}


###
### $cl->start("color") - ColorPanel starten 
###
sub start {
my $self     = shift;
$COLOR    = shift;

&set_color_components($COLOR);

my $top = $self->{'topwin'} = $self->{'parentwin'}->Toplevel();
$self->{'topwin'}->configure(-title => $self->{'title'});

$act_color = $top->Label(-textvariable => \$COLOR);

$rot = $top->Scale(-from => 0, -to => 255, 
                   -orient => "horizontal",
                   -label => "Rot", -command => \&upd_color);
$gruen = $top->Scale(-from => 0, -to => 255, 
                     -orient => "horizontal",
                     -label => "Grn", 
                     -command => \&upd_color);
$blau = $top->Scale(-from => 0, -to => 255, 
                    -orient => "horizontal",
                    -label => "Blau", 
                    -command => \&upd_color);
$set = $top->Button(-text => "Ok",-command => sub { $self->okAction });
$cancel = $top->Button(-text => "Abbrechen",
      					-command => sub { $top->destroy() });  

$act_color->pack(-side => 'top');
$rot->pack(-side => 'top'); 
$gruen->pack(-side => 'top'); 
$blau->pack(-side => 'top');
$set->pack(-side => 'left'); 
$cancel->pack(-side => 'right');

$rot->set($RED);
$gruen->set($GREEN);
$blau->set($BLUE);
 
}

sub set_color_components {
	my $color = shift;

	$color =~ s/^#//;
	$color =~ s/(..)//;
	$RED = hex("$1");
	$color =~ s/(..)//;
	$GREEN = hex("$1");
	$BLUE = hex("$color");
}
# upd_color - Vorder- und Hintergrundfarbe aktualisieren
sub upd_color {
    my $background = "#";
    my $total      = 0;

    # Werte auslesen und numerische Farbbeschreibung aufbauen
    foreach $i ($rot,$gruen,$blau) {
        my $value = $i->get();
        $background .= sprintf("%02x", $value);
        $total += $value;
    }

    # Farbe der Beschriftung in Abhngigkeit von
    # der Gesamthelligkeit
    my $foreground = $total < 255 ? "white" : "black";

	$COLOR = $background;
    foreach $i ($rot,$gruen,$blau) {
        $i->configure(-background => $background, 
                      -foreground => $foreground);
    }
}

sub okAction { 
    my $self = shift;
   
	$self->{'topwin'}->destroy; 
                                 # Callback auslsen
    &{$self->{'callbackref'}}($COLOR);
}

1;
