
###
### Viewfile Class
###
package Viewfile;

use Tk;

local $TEXT;

###
### $vf = Viewfile->new($topwindow) - Neue Viewfile-Instanz
###
sub new {
    my($type, $parentwin) = @_;

    my $self = {};
                                            
    $self->{'parentwin'}   = $parentwin;

    bless($self, $type);
}


###
### $vf->start("File") - File anzeigen
###
sub start {
    my $self     = shift;
    my $file    = shift;
    my $desc    = shift;
	my $time;

    $self->{'topwin'} = $self->{'parentwin'}->Toplevel();

    $self->{'topwin'}->configure(-title => "$file");

	
	# Dateieigenschaften erkundigen (Dateigroesse und die letzte
	# Modifikationszeit
	my @stat_liste = stat $file;
	my $mtime = $stat_liste[9];

	my @ltime = localtime($mtime);	
	my $sek = $ltime[0];
	if ($sek < 10) { $sek = "0$sek"; }
	my $min = $ltime[1];
	if ($min < 10) { $min = "0$min"; }
	my $std = $ltime[2];
	if ($std < 10) { $std = "0$std"; }
	my $tag = $ltime[3];
	my $wochentag = (So,Mo,Di,Mi,Do,Fr,Sa)[$ltime[6]];
	my $monat = (Jan,Feb,Mar,Apr,Mai,Jun,Jul,Aug,Sep,Okt,Nov,Dez)[$ltime[4]];
	my $jahr = 1900+$ltime[5];
	
	$time = "$wochentag $tag.$monat.$jahr, $std:$min:$sek";

	my $fsize = $stat_liste[7];

	$self->{'topwin'}->Label(-text => "Dateiname:\t$file")->pack(-anchor => "nw");
	$self->{'topwin'}->Label(-text => "Gre:\t\t$fsize K")->pack(-anchor => "nw");
	$self->{'topwin'}->Label(-text => "Erstellt am:\t$time")->pack(-anchor => "nw");
	$self->{'topwin'}->Label(-text => "Beschreibung:\t$desc")->pack(-anchor => "nw");

	my $text_frame = $self->{'topwin'}->Frame();
	$TEXT = $text_frame->Text(-borderwidth => 2, -setgrid => 1, -wrap => 'none',
							-background => "white", -height => 30,
							-state => "normal");
	my $yscrollbar = $text_frame->Scrollbar(-command => [yview => $TEXT]);
	my $xscrollbar = $text_frame->Scrollbar(-orient => 'horizontal',
												  -command => [xview => $TEXT]);
	$TEXT->configure(-yscrollcommand => [set => $yscrollbar]);
	$TEXT->configure(-xscrollcommand => [set => $xscrollbar]);
	
	$yscrollbar->pack(-side => 'right', -fill => 'y');
	$TEXT->pack(-side => 'top');
	$xscrollbar->pack(-side => 'top', -fill => 'x');

	$text_frame->pack(-side => 'top');

    $self->{'topwin'}->Button(-text => "Cancel", 
      -command => sub { $self->{'topwin'}->destroy() } 
                             )->pack(-side => 'right');
	&loadfile($file);
	$TEXT->configure(-state => "disabled");
}

sub loadfile {
my $file = shift;
	
  open(FILE, $file) || return 0;
  $TEXT->delete("1.0", "end");
  while(<FILE>) {
  	$TEXT->insert("end", $_);
  }
  close(FILE);

}

1;
