#
# @command HEAD
# @title   Kopf des "Ubungsblattes einf"ugen
# @index   
# @syntax  \#HEAD\{optionen\}
# @desc    Ein spezieller Befehl f"ur den "Ubungsbetrieb der Arbeitsgruppe
#          {\it\dq Praktische Informatik\dq} der Universit"at Osnabr"uck.\\
#          Mit dem Befehl {\tt \#HEAD\{<optionen>\}} wird ein Blattkopf
#          gesetzt. Der Blattkopf kann folgende Informationen enthalten:
#          \begin{itemize}
#          \item Fachbereich
#          \item Internet-Adresse des Fachbereichs
#          \item Name der Lehrveranstaltung
#          \item laufendes Semester
#          \item Verweis auf das Vorlesungsskript im Internet
#          \item Vorlesungs-, "Ubungsleiter
#          \item Verweis auf die Homepages von V- und "U-Leiter
#          \item Ausgabe- und Abgabetermin 
#          \item Abgabeort
#          \end{itemize}
#          Diese Informationen werden von der Initialisierungsdatei
#          {\tt lvprax.ini} oder separat von den {\tt HEAD}-Optionen
#          entnommen. Die Initialisierungsdatei wird mit der
#          Kommandozeilenoption {\tt -init\_file lvprax.ini} (s. Abschnitt
#          \ref{KOZ}) eingebunden. 
# @example_begin
#   #HEAD{blatt=1,ausgabe="21.4.1998",abgabe="28.4.1998",lv=PA}
#   ...
# @example_end
#
#   @optname abgabe
#   @optargs <datum>
#     Abgabetermin des Blattes.
#
#   @optname aufg
#   @optargs <aufgabenummer>
#     Aufgabennummer angeben.
#
#   @optname ausgabe
#   @optargs <datum>
#     Ausgabedatum des Blattes.
#
#   @optname blatt
#   @optargs<blattnummer>
#     Blattn ummer angeben. Wenn diese Option fehlt, bekommt das Blatt die
#     Nummer des vorheriges Blattes plus eins.
#
#   @optname FB
#   @optargs <fachbereich>
#     Mit dieser Option wird der Fachbereich angegeben.
#
#   @optname FB\_http
#   @optlabel FB_http
#   @optargs <fachbereich-adresse>
#     Internet-Adresse des Fachbereichs.
#
#   @optname http
#   @optargs <lehrveranstaltung-adresse>
#     Adresse des Vorlesungsskriptes im Internet.
#
#   @optname kasten
#   @optargs <abgabeort>
#     Abgabeort des Blattes.
#
#   @optname lv
#   @optargs <lehrveranstaltung>
#     Name der Lehrveranstaltung.
#     \\Beispiel: {\tt lv=CG} ({\tt CG} = "`Computergrafik"')
#
#   @optname Prof
#   @optargs <leiter>
#     Leiter der Vorlesung.
#
#   @optname Prof\_http
#   @optlabel Prof_http
#   @optargs <leiter-homepage>
#     Homepage des Leiters.
#
#   @optname semester
#   @optargs <semester>
#     Laufendes Semester.
#
#   @optname Uebung
#   @optargs <"ubungsleiter>
#     "Ubungsleiter.
#
#   @optname Uebung\_http
#   @optlabel Uebung_http
#   @optargs <"ubungsleiter-homepage>
#     Homepage des "Ubungsleiters.
#
#
# @command BLATT
# @title   Blattnummer einf"ugen
# @index   
# @syntax  \#BLATT\{blatt=<blattnr>\}
# @desc    Ein spezieller Befehl f"ur den "Ubungsbetrieb der Arbeitsgruppe
#          {\it\dq Praktische Informatik\dq} der Universit"at Osnabr"uck.\\
#          Die Blattnummer kann mit dem {\tt BLATT}-Befehl neu gesetzt
#          werden. Ohne Angabe der Option {\tt blatt} wird die Blattnummer
#          um eins erh"oht.
# @example_begin
#    #BLATT{blatt=1}
# @example_end
#
#   @optname blatt
#   @optargs blattnr
#     Die Blattnummer wird auf den Wert {\tt blattnr} gesetzt.
#
# @command AUFG
# @title   Aufgabenkopf
# @index   
# @syntax  \#AUFG\{punkte=<punktzahl>\}
# @desc    Ein spezieller Befehl f"ur den "Ubungsbetrieb der Arbeitsgruppe
#          {\it\dq Praktische Informatik\dq} der Universit"at Osnabr"uck.\\
#          Mit dem Befehl {\tt \#AUFG} wird im "Ubungsblatt der Aufgabenkopf 
#          ({\bf Aufgabe } {\it Blattnummer.Aufgabennummer}) gesetzt. Bei jedem
#          Erscheinen des Befehls wird {\it Aufgabennummer} inkrementiert.
#          In der HTML-Version wird an der Stelle ein Link auf die Aufgabe gesetzt.
# @example_begin
#   #AUFG{punkte=10}
#   Aufgabe mit 10 Punkten.
#   #AUFG{punkte=5}
#   Aufgabe mit 5 Punkten.
# @example_end
#
#   @optname punkte
#   @optargs <punktzahl>
#     Die Punkte {\tt punktzahl} f"ur die Aufgabe eingeben.
#
# @command AUFGREF
# @title   Aufgaben referenzieren
# @index   
# @syntax  \#AUFGREF\{label\}
# @desc    Ein spezieller Befehl f"ur den "Ubungsbetrieb der Arbeitsgruppe
#          {\it\dq Praktische Informatik\dq} der Universit"at Osnabr"uck.\\
#          Der Befehl {\tt \#AUFGREF} erzeugt eine Referenz auf eine bestimmte Aufgabe. 
#          In der HTML-Version wird ein Link auf die Aufgabe gesetzt.
# @example_begin
#   Siehe die Aufgabe #AUFGREF{aufg1.2} mit 5 Punkten.
# @example_end
#
#   @optname aufg<blattnr>.<aufgnr>
#     Referenziert die Aufgabe {\tt <aufgnr>} auf Blatt {\tt <blattnr>}.
#
# @command TIME
# @title   Zeitlich bedingter Text
# @index   
# @syntax  \#TIME\{optionen\}
# @desc    Ein spezieller Befehl f"ur den "Ubungsbetrieb der Arbeitsgruppe
#          {\it\dq Praktische Informatik\dq} der Universit"at Osnabr"uck.\\
#          {\tt \#TIME} ist eine zeitliche Umgebung. Diese Umgebung erweist
#          sich als zweckm"a"sig z.B. f"ur den "Ubungsbetrieb einer Veranstaltung.
#          (Die Musterl"osungen erscheinen ab einem bestimmten Datum im Dokument.)
#          Oder das Vorlesungsskript wird bez"uglich der Vorlesungstermine
#          st"uckweise ver"offentlicht.
# @example_begin
#   #TIME{begin=28.5.98-15:45,alttext="Musterl\"osung "}
#   {\bf Musterl"osung}\\
#   Hier ist die Musterl"osung.
#   #TIME{end}
# @example_end
#
#   @optname begin
#   @optargs <tag.monat.jahr-std:min>
#     Die Umgebung wird ge"offnet. Zeit des Erscheinens wird gesetzt auf
#     {\tt tag.monat.jahr-std:min}. Vor diesem Zeitpunkt ist die Umgebung unsichtbar.
#     \\Defaultwert: {\tt 18:00} f"ur Stundenzeit 
#
#   @optname alttext
#   @optargs \dq ersatztext\dq
#     Bei unsichtbarer Umgebung erscheint in der HTML-Version
#     {\tt ersatztext} mit dem Er"offnungsdatum im Dokument.
#
#   @optname end
#     Die Umgebung beenden.
#
# @end

$BNR;         # Blattnummer
$ANR;         # Aufgabenummer
$ABGABE;      # Abgabetermin

@TIME_OK;     # Umgebungsarray
              # Wird um einen 'true'-Wert erweitert, 
              # wenn TIME-Umgebung begint
# HEAD-Befehl
sub head_work {
  package head;

  my $use_FB;
  my $use_FB_http;
  my $use_Prof;
  my $use_Uebung;
  my $use_Prof_http;
  my $use_Uebung_http;
  my $use_kasten;
  my $use_tutorial;
  my $use_time;
  my $use_semester;
  my $use_http;
  my ($wert,$flag);
  my ($use_blatt,$use_aufg,$use_ausgabe,$use_abgabe);
  my $use_lv;
  local $COMMAND=shift @_;
  local (@PARAMS) = @_;      # uebergebene Liste

  # wenn keine Erlaubung zum Schreiben, dann Ausstieg
  unless ($main::TEXFILE_WRITE_OK) {return;}

  # Flags setzen
  foreach $term (@PARAMS) {    
    ($flag,$wert)=&main::my_quotewords("=",0,$term);
    $flag =~ s/(\s*)//g;      # Trennzeichen loeschen
    SWITCH: {
      if ($flag eq "blatt") {$use_blatt=$wert; last SWITCH;}
      if ($flag eq "aufg") {$use_aufg=$wert; last SWITCH;}
      if ($flag eq "ausgabe") {$use_ausgabe=$wert; last SWITCH;}
      if ($flag eq "abgabe") {$use_abgabe=$wert; last SWITCH;}
      if ($flag eq "lv") {$use_lv=$wert; last SWITCH;}
      if ($flag eq "FB") {$use_FB=""; $use_FB=$wert; last SWITCH;}
      if ($flag eq "FB_http") {$use_FB_http=""; $use_FB_http=$wert; last SWITCH;}
      if ($flag eq "Prof") {$use_Prof=""; $use_Prof=$wert; last SWITCH;}
      if ($flag eq "Prof_http") {$use_Prof_http=""; $use_Prof=$wert; last SWITCH;}
      if ($flag eq "Uebung") {$use_Uebung=""; $use_Uebung=$wert; last SWITCH;}
      if ($flag eq "Uebung_http") {$use_Uebung_http=""; $use_Uebung=$wert; last SWITCH;}
      if ($flag eq "http") {$use_http=""; $use_http=$wert; last SWITCH;}
      if ($flag eq "kasten") {$use_kasten=""; $use_kasten=$wert; last SWITCH;}
      if ($flag eq "semester") {$use_semester=""; $use_semester=$wert; last SWITCH;}
      &main::my_exit("Unknown flag in $COMMAND : $flag\n");
    }
  }

  &to_flag_check;

  # Initialisierung von der Felder auf dem Blatt
  # Diese Variablen werden von einer Datei inizialisiert
  $use_FB = $main::FB_NAME unless ($use_FB);
  $use_FB_http = $main::FB_HTTP unless ($use_FB_http);
  $use_Prof = $main::FB{$use_lv}{'Prof'} unless ($use_Prof);
  $use_Uebung = $main::FB{$use_lv}{'Uebung'} unless ($use_Uebung);
  $use_Prof_http = $main::FB{$use_lv}{'Prof_http'} unless ($use_Prof_http);
  $use_Uebung_http = $main::FB{$use_lv}{'Uebung_http'} unless ($use_Uebung_http);
  $use_kasten = $main::FB{$use_lv}{'Kasten'} unless ($use_kasten);
  $use_tutorial = $main::FB{$use_lv}{'Abgabe'} unless ($use_tutorial);
  $use_time = $main::FB{$use_lv}{'Zeit'} unless ($use_time);
  $use_semester = $main::FB{$use_lv}{'Semester'} unless ($use_semester);
  $use_http = $main::FB{$use_lv}{'HTTP'} unless ($use_http);
  $use_lv = $main::FB{$use_lv}{'LV'} if ($main::FB{$use_lv}{'LV'});

  # Entsprechende Mechanismen aufrufen
  if ($main::OUTPUTFORMAT eq "html") {&html_work;}
  if ($main::OUTPUTFORMAT eq "latex") {&latex_work;}
  
  if ($use_blatt) { $main::BNR = $use_blatt; }
  else { $main::BNR = 1; }      # Setze den Zaehler auf 1

  $main::ANR = $use_aufg;
  $main::ABGABE = $use_abgabe;

  return 1;
  

  # die Flags ueberpruefen
  sub to_flag_check {
    unless (exists $main::FB{$use_lv}) {
      &main::my_msg("Fehlende Einstellungen fuer die LV=$use_lv.\n");
    }
    if (!($use_blatt)) {    # Dann Blatt0
      $use_blatt0=1;
    }
    if ($use_aufg =~ /(\D+)/) {
      &main::my_msg("Flag \'aufg\' in $COMMAND desire number only.\n");
    }
    if (!($use_aufg)) {$use_aufg=1;}
  }
  
  
  # Head-Subroutine
  # Nach Bedarf den zu auszugebenden Inhalt aendern
  sub latex_work {
    &main::write_to_texfile(
      "% *** Master-Generator - HEAD ***\n".
      "% BEGIN : Blatt$use_blatt\n".
      "\\noindent\n".
      "$use_FB \\hfill Universit\"at Osnabr\"uck"
    ); 
    if ($use_blatt0) { &main::write_to_texfile("\\\\ \n"); }
    else { &main::write_to_texfile(", $use_ausgabe\\\\ \n");}
    &main::write_to_texfile("$use_Prof ") if ($use_Prof);
    $use_http = &main::link_to_latex($use_http);
    if ($use_blatt0) { &main::write_to_texfile("\\\\\n");}
    else { &main::write_to_texfile("\\hfill {\\tt $use_http}\\\\\n") if ($use_http); }
    &main::write_to_texfile("$use_Uebung ") if ($use_Uebung);
    if ($use_blatt0) { &main::write_to_texfile("\n");}
    else {&main::write_to_texfile("\\hfill $use_tutorial bis $use_abgabe, $use_time Uhr $use_kasten\n");}
    &main::write_to_texfile(
      "\\begin{center}\n".
      "{\\Large \\bf \"Ubungen zu $use_lv} \\\\[3mm]\n"
    );
    &main::write_to_texfile("{\\it $use_semester} \\\\[3mm]\n") if ($use_semester);
    if ($use_blatt0) { $main::ANR =1; }
    else { &main::write_to_texfile("{\\bf Blatt $use_blatt}\n");}
    &main::write_to_texfile("\\end{center}\n");
  }
  
  sub html_work {
   &main::write_to_texfile(
     "\\begin{rawhtml}\n".
     "<table cellpadding=0><tr><td width=\"100%\">\n".
     "\\end{rawhtml}\n".
     "\n".
     "\\htmladdnormallink{$use_FB}{$use_FB_http}\n".
     "\n".
     "\\begin{rawhtml}\n".
     "</td><td nowrap align=right>\n".
     "\\end{rawhtml}\n".
     "\n".
     "\\htmladdnormallink{Universit\"at Osnabr\"uck}{http://www.uni-osnabrueck.de}"
   );
   if ($use_blatt) {&main::write_to_texfile(",  $use_ausgabe");}
   &main::write_to_texfile(
     "\n\n".
     "\\begin{rawhtml}\n".
     "</td></tr><tr><td>\n".
     "\\end{rawhtml}\n".
     "\n".
     "\\htmladdnormallink{$use_Prof}{$use_Prof_http}\n".
     "\n"
   ); 
   if ($use_blatt) {
     &main::write_to_texfile(
       "\\begin{rawhtml}\n".
       "</td><td nowrap align=right>\n".
       "\\end{rawhtml}\n".
       "\n".
       "letzter Abgabetermin: $use_abgabe\n".
       "\n"
   );
   }
   &main::write_to_texfile(
     "\\begin{rawhtml}\n".
     "</td></tr><tr><td>\n".
     "\\end{rawhtml}\n".
     "\n".
     "\\htmladdnormallink{$use_Uebung}{$use_Uebung_http}\n".
     "\n".
     "\\begin{rawhtml}\n".
     "</td></tr></table>\n".
     "\\end{rawhtml}\n".
     "\n".
     "\\begin{center}\n".
     "{\\Large\\bf \\\"Ubungen zu \\htmladdnormallink{$use_lv}{$use_http}}\\\\[3mm]\n"
   );
   &main::write_to_texfile("{\\em $use_semester}\\\\[3mm]\n") if ($use_semester);
   if ($use_blatt) {&main::write_to_texfile("{\\bf Blatt $use_blatt}\n");}
   else {$main::ANR=1}
   &main::write_to_texfile("\\end{center}\n");
  }
}

# AUFG
sub aufg_work {
  package aufg;

  my $COMMAND=shift @_;
  my $term=shift;
  my ($flag,$wert);
  my $nummer;
  local $use_punkte;
  
  # wenn keine Erlaubung zum Schreiben, dann Ausstieg
  unless ($main::TEXFILE_WRITE_OK) {return;}

  $term =~ s/(\s+)//g;      # Trennzeichen loeschen
  ($flag,$wert)=&main::my_quotewords("=",0,$term);

  if ($flag eq "punkte") { $use_punkte = "($wert Punkte)"; }
  elsif ($flag eq "") {$use_punkte = ""; }
  else { &main::my_exit("Unknown flag in $COMMAND : $flag\n"); }
  &make_aufg;

  sub make_aufg {
    if ($main::BNR) { $nummer = "$main::BNR.$main::ANR"; }
    else { $to_label = "$main::ANR"; }
    &main::my_print("AUFGABE $nummer\n");
    &main::write_to_texfile("% *** Master-Generator - AUFG ***\n");
    if ($main::OUTPUTFORMAT eq "html") {
      &main::write_to_texfile("\\subsubsection*{Aufgabe $nummer $use_punkte}\n");
      &main::write_to_texfile("\\label{aufg$nummer}\n");
    }

    if ($main::OUTPUTFORMAT eq "latex") {
      &main::write_to_texfile("\n{\\bf Aufgabe $nummer $use_punkte\\\\[3mm]}\n");
    }
    $main::ANR++;  # Aufgabenummer inkrementieren
  }
}

# AUFGREF
# Damit wird eine Referenz, bzw. ein Link auf die Aufgabe erzeugt
sub aufgref_work {
  my $COMMAND=shift;
  my $term = shift;
  my $ref;

  # wenn keine Erlaubung zum Schreiben, dann Ausstieg
  unless ($main::TEXFILE_WRITE_OK) {return;}

  $term =~ s/(\s+)//g;      # Trennzeichen loeschen
  if ((!($term =~ /^(aufg)(\d+)\.(\d+)$/))&&(!($term =~ /^(aufg)(\d+)$/))) {
    &main::my_msg("Unknown reference \'$term\' in $COMMAND.\n");
    return;
  }
  $ref = $term;
  $ref =~ s/aufg//;      # Blattnummer + Aufgabennummer erfahren
  
  if ($main::OUTPUTFORMAT eq "html") {
    &main::write_to_texfile("\\htmlref{$ref}{$term}\n");
  } else {
    &main::write_to_texfile(" $ref ");
  }
}

# BLATT
sub blatt_work {
  package blatt;
  my $COMMAND=shift @_;
  my $term=shift;
  my ($flag,$wert);
  local $use_blatt;

  # wenn keine Erlaubung zum Schreiben, dann Ausstieg
  unless ($main::TEXFILE_WRITE_OK) {return;}

  ($flag,$wert)=&main::my_quotewords("=",0,$term);
  $flag =~ s/(\s*)//g;      # Trennzeichen loeschen

  if ($flag eq "blatt") {$use_blatt = $wert;}
  elsif ($flag eq "") { $main::BNR++; }
  else {&main::my_exit("Unknown flag in $COMMAND : $flag\n");}

  if (($use_blatt)&&($use_blatt =~ /(\D+)/)) {
    &main::my_msg("Flag \'blatt\' in $COMMAND desire number only.\n");
  }
  &main::my_print("BLATT $main::BNR\n");
  &make_blatt;

  sub make_blatt {
    $main::ANR = 1;
    if ($use_blatt) { $main::BNR = $use_blatt; }
  }

}

# MUSTERTEX
sub mustertex_work {
  package mustertex;

  my ($wert,$flag);
  my ($use_date,$use_file,$use_texfile);
  local $COMMAND=shift @_;
  local (@PARAMS) = @_;      # uebergebene Liste

  # wenn keine Erlaubung zum Schreiben, dann Ausstieg
  unless ($main::TEXFILE_WRITE_OK) {return;}

  # Flags setzen
  foreach $term (@PARAMS) {    
    $term =~ s/(\s*)//g;      # Trennzeichen loeschen
    ($flag,$wert)=&main::my_quotewords("=",0,$term);
    SWITCH: {
      if ($flag eq "file") {$use_file=$wert; last SWITCH;}
      if ($flag eq "texfile") {$use_texfile=$wert; last SWITCH;}
      if ($flag eq "date") {$use_date=$wert; last SWITCH;}
      &main::my_exit("Unknown flag in $COMMAND : $flag\n");
    }
  }
  if ($main::OUTPUTFORMAT eq "html") {
    if (!($use_file =~ /(.*)html$/)) { $use_file .= ".html"; }
     &main::write_to_texfile("\\\\ {\\bf Musterl\"osung} (ab $main::ABGABE):");
     &main::write_to_texfile(" \\htmladdnormallink{ $use_file}{../../../$use_file}");
  }
  if ($main::OUTPUTFORMAT eq "latex") {
    if (!($use_texfile =~ /(.*)TEX$/)) { $use_texfile .= ".TEX"; }
     &main::write_to_texfile("\\vspace*{1cm}\n");
     &main::write_to_texfile("{\\bf Musterl\"osung vom $use_date:\\\\}\n");
     &main::write_to_texfile("\\input{../../$use_texfile}\n");
  }
}

sub get_time {
  package time;
  my $use_time=shift @_;
  my ($min,$std,$tag,$wochentag,$mon,$jahr);
  # Die Werte ermitteln
  ($date,$time) = split /-/, $use_time;
  ($tag,$mon,$jahr) = split /\./, $date;
  ($std,$min) = split /:/, $time;
  
  if (!($std)) { $std = 18; $min = 0; }   # Default-Werte
  $mon--;      # Monat begint mit 0
  if (($min =~ /(\D+)/)|| ($std =~ /(\D+)/)|| ($tag =~ /(\D+)/)||
  ($mon =~ /(\D+)/)|| ($jahr =~ /(\D+)/)) {
    &main::my_exit("Error value for begin in TIME : $use_time\n");
  }
  return timelocal(0,$min,$std,$tag,$mon,$jahr);
}

sub time_work {
  package time;
  use Time::Local;
  my ($wert,$flag);
  my $use_boom="";
  my $date,$time;
  my ($boom_time,$real_time,$end_time);
  my ($min,$std,$tag,$wochentag,$mon,$jahr);
  my $use_package="";
  my $use_begin="";
  my $use_endtime="";
  my $use_end="";
  my $use_alttext="";
  my $term;
  my $write_status;
  my @ltime;
  local $COMMAND=shift @_;
  local (@PARAMS) = @_;      # uebergebene Liste

  # Flags setzen
  foreach $term (@PARAMS) {    
    ($flag,$wert)=&main::my_quotewords("=",0,$term);
    $flag =~ s/(\s*)//g;      # Trennzeichen loeschen
    SWITCH: {
      if ($flag eq "begin") {
        if ($use_end) {
          &main::my_exit("$COMMAND : \'begin'\ and \'end\' in one\n");
        }
        $use_begin=1; 
        $use_boom=$wert;
        last SWITCH;
      }
      if ($flag eq "alttext") {$use_alttext=$wert; last SWITCH;}
      if ($flag eq "endtime") {$use_endtime=$wert; last SWITCH;}
      if ($flag eq "end") {
        if ($use_begin) {
          &main::my_exit("$COMMAND : \'begin'\ and \'end\' in one\n");
        }
        $use_end=1; last SWITCH;
      }
      &main::my_exit("Unknown flag in $COMMAND : $flag\n");
    }
  }
  
  if ($use_begin) {
    unshift @main::TIME_OK,$main::TEXFILE_WRITE_OK+1;
    if ($use_boom) {
      # Zeit ausrechnen in Sekunden
      $boom_time=&::get_time("$use_boom");
      if ($use_endtime) {
        # Zeit ausrechnen in Sekunden
        $end_time=&::get_time("$use_endtime");
      }
      # Aktuelle Zeit ermitteln
      $real_time=time();

      @ltime=localtime($boom_time); 
      $min = $ltime[1];
      if ($min < 10) { $min = "0$min"; }
      $std = $ltime[2];
      if ($std < 10) { $std = "0$std"; }
      $tag = $ltime[3];
      $wochentag = (So,Mo,Di,Mi,Do,Fr,Sa)[$ltime[6]];
      $monat = (Jan,Feb,Mar,Apr,Mai,Jun,Jul,Aug,Sep,Okt,Nov,Dez)[$ltime[4]];
      $jahr = 1900+$ltime[5];

      if ($boom_time > $real_time) {
        &main::my_print("TIME : wait for $wochentag $tag $monat $jahr $std:$min\n");
        $main::TEXFILE_WRITE_OK=0;
        &main::wait_of_command("TIME"); # warte auf TIME
        if (($use_alttext)&&($main::OUTPUTFORMAT eq "html")) {
          print main::OUT "\\begin{rawhtml}\n";
          print main::OUT "<BR><P>\n";
          print main::OUT "\\end{rawhtml}\n";
          print main::OUT "{\\bf $use_alttext (ab $use_boom)}\n";
          print main::OUT "\\begin{rawhtml}\n";
          print main::OUT "<BR><P>\n";
          print main::OUT "\\end{rawhtml}\n";
        }
      } else {
        if ($use_endtime) {
          if ($end_time < $real_time) {
            $main::TEXFILE_WRITE_OK=0;
            &main::wait_of_command("TIME"); # warte auf TIME
          }
        } else {
          &main::my_print("TIME : expand of $wochentag $tag $monat $jahr $std:$min\n");
        }
      }
    }
  }

  if ($use_end) {
    $write_status = shift @main::TIME_OK;
    unless ($write_status) { &main::my_exit("\#TIME{end} without \#TIME{begin}\n"); }
    $main::TEXFILE_WRITE_OK=$write_status-1;
    &main::wait_of_command("");    # Akzeptiere alle weitere 
                    # Befehle
  }
}

$MANAGEFUNKTION->{HEAD}      = \&head_work;
$MANAGEFUNKTION->{AUFG}      = \&aufg_work;
$MANAGEFUNKTION->{BLATT}     = \&blatt_work;
$MANAGEFUNKTION->{MUSTERTEX} = \&mustertex_work;
$MANAGEFUNKTION->{MUSTERLSG} = \&musterlsg_work;
$MANAGEFUNKTION->{TIME}      = \&time_work;
$MANAGEFUNKTION->{AUFGREF}   = \&aufgref_work;

1;
