#
# @command R
# @title   Einf"ugen von Stichworten in den Report
# @index   
# @syntax  \#R\{\dq stichwort\dq\}
# @desc    Im Report-Modus wird das angegebene Stichwort in das
#          Report-Dokument "ubernommen.
# @example_begin
#    Dolby-System enth"alt eine #R{"Kompressorstufe"} im Aufnahme- und
#    eine #R{"Expansionsstufe"} im Wiedergabeteil.
# @example_end
#
#   @optname stichwort
#     Stichwort, da"s in den Report aufgenommen werden soll. Arbeitet
#     mas2tex nicht im Report-Modus wird das Stichwort ganz normal in
#     den Text "ubernommen.
#
# @command RR
# @title   Einf"ugen von Textteilen in den Report
# @index   
# @syntax  \#REPORT\{begin\}\\Text\\\#REPORT\{end\}
# @desc    Im Report-Modus wird der in der Umgebung enthaltene Text
#          in das Report-Dokument "ubernommen.
# @example_begin
#   % Diese Definition wird komplett in den Report aufgenommen.
#   #RR{begin}
#   {\bf Definition:}
#   \begin{quote} 
#   Dolby-System ist ein elektronisches Verfahren zur
#   Rauschunterdr"uckung in musikelektronischen Ger"aten.
#   \end{quote}
#   #RR{end}
# @example_end
#
# @end

# Report-Bibliothek
$REPORT_STATE;
sub report_work {
  package report;

  my $COMMAND = shift @_;
  my (@PARAMS) = @_;      # uebergebene Liste
  my $flag;
  my $text;

  if ($COMMAND eq "R") {
    $text = shift @PARAMS;
    #&main::my_print("Ich bin in Report mit $text\n");
    if (($main::REPORT)||($main::SELF_REPORT)) {
      &main::master_write("\% Report-Eintrag\n");
      &main::master_write("\\begin\{itemize\}\n");
      &main::master_write("\\item \{\\em $text\}\n");
      &main::master_write("\\end\{itemize\}\n");
    } else {
      &main::write_to_texfile("$text");
    }

  } elsif ($COMMAND eq "RR") {
    $flag = shift @PARAMS;
    if ((!($main::REPORT))&&(!($main::SELF_REPORT))) { return; }
    if ($flag eq "begin") {
      &main::master_write("\% Report-Umgebung \(begin\)\n");
      $main::REPORT_STATE = $main::REPORT_WRITE;
      $main::REPORT_WRITE = 1;
    } elsif ($flag eq "end") {
      $main::REPORT_WRITE = $main::REPORT_STATE;
      &main::master_write("\% Report-Umgebung \(end\)\n");
    } else {
      &main::my_exit("Unknown flag in $COMMAND : $flag\n");
    }
  } 
}

$MANAGEFUNKTION->{R}  = \&report_work;
$MANAGEFUNKTION->{RR} = \&report_work;

1;
